##// END OF EJS Templates
add bc if uboot gets compiled
Unknown -
r323:3bb7303416dc
parent child
Show More
@@ -1,99 +1,101
1 1 #!/bin/bash
2 2 #
3 3 # Build and Setup U-Boot
4 4 #
5 5
6 6 # Load utility functions
7 7 . ./functions.sh
8 8
9 9 # Fetch and build U-Boot bootloader
10 10 if [ "$ENABLE_UBOOT" = true ] ; then
11 11 # Install c/c++ build environment inside the chroot
12 12 chroot_install_cc
13 13
14 14 # Copy existing U-Boot sources into chroot directory
15 15 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
16 16 # Copy local U-Boot sources
17 17 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
18 18 else
19 19 # Create temporary directory for U-Boot sources
20 20 temp_dir=$(as_nobody mktemp -d)
21 21
22 22 # Fetch U-Boot sources
23 23 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
24 24
25 25 # Copy downloaded U-Boot sources
26 26 mv "${temp_dir}/u-boot" "${R}/tmp/"
27 27
28 28 # Set permissions of the U-Boot sources
29 29 chown -R root:root "${R}/tmp/u-boot"
30 30
31 31 # Remove temporary directory for U-Boot sources
32 32 rm -fr "${temp_dir}"
33 33 fi
34 34
35 35 # Build and install U-Boot inside chroot
36 36 chroot_exec make -j"${KERNEL_THREADS}" -C /tmp/u-boot/ "${UBOOT_CONFIG}" all
37 37
38 38 # Copy compiled bootloader binary and set config.txt to load it
39 39 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
40 40 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
41 41 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
42 42
43 43 # Install and setup U-Boot command file
44 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
45 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat "${BOOT_DIR}"/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
46 #Set correkt KERNEL_IMAGE
44 # Set correct KERNEL_IMAGE in mkfile
47 45 sed -i "s/kernel7.img/$KERNEL_BIN_IMAGE/g" files/boot/uboot.mkimage
48 46 #Set correct DTB_FILE
49 47 sed -i "s/bcm2709-rpi-2-b.dtb/$DTB_FILE/g" files/boot/uboot.mkimage
48 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
49 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat "${BOOT_DIR}"/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
50 50
51 51 if [ "$ENABLE_INITRAMFS" = true ] ; then
52 52 # Convert generated initramfs for U-Boot using mkimage
53 53 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
54 54
55 55 # Remove original initramfs file
56 56 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
57 57
58 58 # Configure U-Boot to load generated initramfs
59 59 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat "${BOOT_DIR}"/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
60 60 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
61 61 else # ENABLE_INITRAMFS=false
62 62 # Remove initramfs from U-Boot mkfile
63 63 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
64 64
65 65 if [ "$BUILD_KERNEL" = false ] ; then
66 66 # Remove dtbfile from U-Boot mkfile
67 67 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
68 68 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
69 69 else
70 70 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
71 71 fi
72 72 fi
73 73
74 74 if [ "$SET_ARCH" = 64 ] ; then
75 75 echo "Setting up config.txt to boot 64bit uboot"
76 printf \n# Tell u-boot a 64bit kernel is used\narm_64bit=1\n" >> "${BOOT_DIR}/config.txt"
77 printf \n# Device tree start addr\ndevice_tree_address=0x100\n" >> "${BOOT_DIR}/config.txt"
78 printf \n# Device tree stop adrr\ndevice_tree_end=0x8000\n" >> "${BOOT_DIR}/config.txt"
79 #to config.txt
76 printf "\n# Tell u-boot a 64bit kernel is used\narm_64bit=1\n" >> "${BOOT_DIR}/config.txt"
77 printf "\n# Device tree start addr\ndevice_tree_address=0x100\n" >> "${BOOT_DIR}/config.txt"
78 printf "\n# Device tree stop adrr\ndevice_tree_end=0x8000\n" >> "${BOOT_DIR}/config.txt"
80 79 fi
81 80
82 81 # Set mkfile to use the correct mach id
83 82 if [ "$ENABLE_QEMU" = true ] ; then
84 83 sed -i "s/^\(setenv machid \).*/\10x000008e0/" "${BOOT_DIR}/uboot.mkimage"
85 84 fi
86 85
86 # Set mkfile to use the correct dtb file
87 sed -i "s/^\(setenv dtbfile \).*/\1${DTB_FILE}/" "${BOOT_DIR}/uboot.mkimage"
88
87 89 # Set mkfile to use kernel image
88 sed -i "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
90 sed "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
89 91
90 92 # Remove all leading blank lines
91 93 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
92 94
93 95 # Generate U-Boot bootloader image
94 96 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
95 97
96 98 # Remove U-Boot sources
97 99 rm -fr "${R}/tmp/u-boot"
98 100 fi
99 101
@@ -1,757 +1,757
1 1 #!/bin/bash
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 #Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 56 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 57
58 58 # Firmware directory: Blank if download from github
59 59 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
60 60
61 61 # Build directories
62 62 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
63 63 BUILDDIR="${BASEDIR}/build"
64 64
65 65 # Prepare date string for default image file name
66 66 DATE="$(date +%Y-%m-%d)"
67 67 if [ -z "$KERNEL_BRANCH" ] ; then
68 68 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 69 else
70 70 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
71 71 fi
72 72
73 73 # Chroot directories
74 74 R="${BUILDDIR}/chroot"
75 75 ETC_DIR="${R}/etc"
76 76 LIB_DIR="${R}/lib"
77 77 BOOT_DIR="${R}/boot/firmware"
78 78 KERNEL_DIR="${R}/usr/src/linux"
79 79 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
80 80
81 81 # General settings
82 82 SET_ARCH=${SET_ARCH:=32}
83 83 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
84 84 PASSWORD=${PASSWORD:=raspberry}
85 85 USER_PASSWORD=${USER_PASSWORD:=raspberry}
86 86 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
87 87 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
88 88 EXPANDROOT=${EXPANDROOT:=true}
89 89
90 90 # Keyboard settings
91 91 XKB_MODEL=${XKB_MODEL:=""}
92 92 XKB_LAYOUT=${XKB_LAYOUT:=""}
93 93 XKB_VARIANT=${XKB_VARIANT:=""}
94 94 XKB_OPTIONS=${XKB_OPTIONS:=""}
95 95
96 96 # Network settings (DHCP)
97 97 ENABLE_DHCP=${ENABLE_DHCP:=true}
98 98
99 99 # Network settings (static)
100 100 NET_ADDRESS=${NET_ADDRESS:=""}
101 101 NET_GATEWAY=${NET_GATEWAY:=""}
102 102 NET_DNS_1=${NET_DNS_1:=""}
103 103 NET_DNS_2=${NET_DNS_2:=""}
104 104 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
105 105 NET_NTP_1=${NET_NTP_1:=""}
106 106 NET_NTP_2=${NET_NTP_2:=""}
107 107
108 108 # APT settings
109 109 APT_PROXY=${APT_PROXY:=""}
110 110 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
111 111
112 112 # Feature settings
113 113 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
114 114 ENABLE_I2C=${ENABLE_I2C:=false}
115 115 ENABLE_SPI=${ENABLE_SPI:=false}
116 116 ENABLE_IPV6=${ENABLE_IPV6:=true}
117 117 ENABLE_SSHD=${ENABLE_SSHD:=true}
118 118 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
119 119 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
120 120 ENABLE_SOUND=${ENABLE_SOUND:=true}
121 121 ENABLE_DBUS=${ENABLE_DBUS:=true}
122 122 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
123 123 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
124 124 ENABLE_XORG=${ENABLE_XORG:=false}
125 125 ENABLE_WM=${ENABLE_WM:=""}
126 126 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
127 127 ENABLE_USER=${ENABLE_USER:=true}
128 128 USER_NAME=${USER_NAME:="pi"}
129 129 ENABLE_ROOT=${ENABLE_ROOT:=false}
130 130 ENABLE_QEMU=${ENABLE_QEMU:=false}
131 131
132 132 # SSH settings
133 133 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
134 134 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
135 135 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
136 136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
137 137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
138 138
139 139 # Advanced settings
140 140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
141 141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
142 142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
143 143 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
144 144 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
145 145 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
146 146 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
147 147 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
148 148 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
149 149 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
150 150 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
151 151 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
152 152
153 153 # Kernel compilation settings
154 154 BUILD_KERNEL=${BUILD_KERNEL:=true}
155 155 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
156 156 KERNEL_THREADS=${KERNEL_THREADS:=1}
157 157 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
158 158 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
159 159 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
160 160 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
161 161 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
162 162
163 163 # Kernel compilation from source directory settings
164 164 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
165 165 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
166 166 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
167 167 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
168 168
169 169 # Reduce disk usage settings
170 170 REDUCE_APT=${REDUCE_APT:=true}
171 171 REDUCE_DOC=${REDUCE_DOC:=true}
172 172 REDUCE_MAN=${REDUCE_MAN:=true}
173 173 REDUCE_VIM=${REDUCE_VIM:=false}
174 174 REDUCE_BASH=${REDUCE_BASH:=false}
175 175 REDUCE_HWDB=${REDUCE_HWDB:=true}
176 176 REDUCE_SSHD=${REDUCE_SSHD:=true}
177 177 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
178 178
179 179 # Encrypted filesystem settings
180 180 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
181 181 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
182 182 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
183 183 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
184 184 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
185 185
186 186 # Chroot scripts directory
187 187 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
188 188
189 189 # Packages required in the chroot build environment
190 190 APT_INCLUDES=${APT_INCLUDES:=""}
191 191 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
192 192
193 193 # Packages required for bootstrapping
194 194 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
195 195 MISSING_PACKAGES=""
196 196
197 197 # Packages installed for c/c++ build environment in chroot (keep empty)
198 198 COMPILER_PACKAGES=""
199 199
200 200 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
201 201 if [ -n "$SET_ARCH" ] ; then
202 202 echo "Setting Architecture specific settings"
203 203 ##################################
204 204 # 64 bit config
205 205 ##################################
206 206 if [ "$SET_ARCH" = 64 ] ; then
207 207 echo "64 bit mode selected - Setting up enviroment"
208 208 # 64 bit depended settings
209 209 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
210 210 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
211 211 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
212 212
213 213 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
214 214 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
215 215 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
216 216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 217 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
218 218 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
219 219 else
220 220 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
221 221 exit 1
222 222 fi
223 223 fi
224 224
225 225 ##################################
226 226 # 32 bit config
227 227 ##################################
228 228 if [ "$SET_ARCH" = 32 ] ; then
229 229 echo "32 bit mode selected - Setting up enviroment"
230 230 #General 32bit configuration
231 231 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
232 232 KERNEL_ARCH=${KERNEL_ARCH:=arm}
233 233 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
234 234
235 235 #Raspberry setting grouped by board compability
236 236 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
237 237 echo "Setting settings for bcm2835 Raspberry PI boards"
238 238 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
239 239 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
240 240 RELEASE_ARCH=${RELEASE_ARCH:=armel}
241 241 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
242 242 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
243 243 fi
244 244 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
245 245 echo "Setting settings for bcm2837 Raspberry PI boards"
246 246 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
247 247 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
248 248 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
249 249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
250 250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
251 251 fi
252 252 fi
253 253 #SET_ARCH not set
254 254 else
255 255 echo "error: Please set '32' or '64' as value for SET_ARCH"
256 256 exit 1
257 257 fi
258 258
259 259 #Device specific configuration
260 260 echo "Select DTB-File"
261 261 case "$RPI_MODEL" in
262 262 0)
263 263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
264 264 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
265 265 ;;
266 266 1)
267 267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
268 268 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
269 269 ;;
270 270 1P)
271 271 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
272 272 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
273 273 ;;
274 274 2)
275 275 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
276 276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
277 277 ;;
278 278 3)
279 279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
280 280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
281 281 ;;
282 282 3P)
283 283 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
284 284 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
285 285 ;;
286 286 *)
287 287 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
288 288 exit 1
289 289 ;;
290 290 esac
291 291 echo "$DTB_FILE selected"
292 292
293 293 #DEBUG off
294 294 set +x
295 295
296 296 # Check if the internal wireless interface is supported by the RPi model
297 297 if [ "$ENABLE_WIRELESS" = true ] ; then
298 298 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
299 299 echo "error: The selected Raspberry Pi model has no internal wireless interface"
300 300 exit 1
301 301 else
302 302 echo "Raspberry Pi $RPI_MODEL has WIFI support"
303 303 fi
304 304 fi
305 305
306 306 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
307 307 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
308 308 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
309 309 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
310 310 exit 1
311 311 fi
312 312 fi
313 313
314 314 # Add libncurses5 to enable kernel menuconfig
315 315 if [ "$KERNEL_MENUCONFIG" = true ] ; then
316 316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
317 317 fi
318 318
319 319 # Add ccache compiler cache for (faster) kernel cross (re)compilation
320 320 if [ "$KERNEL_CCACHE" = true ] ; then
321 321 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
322 322 fi
323 323
324 324 # Add cryptsetup package to enable filesystem encryption
325 325 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
326 326 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
327 327 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
328 328
329 329 if [ -z "$CRYPTFS_PASSWORD" ] ; then
330 330 echo "error: no password defined (CRYPTFS_PASSWORD)!"
331 331 exit 1
332 332 fi
333 333 ENABLE_INITRAMFS=true
334 334 fi
335 335
336 336 # Add initramfs generation tools
337 337 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
338 338 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
339 339 fi
340 340
341 341 # Add device-tree-compiler required for building the U-Boot bootloader
342 342 if [ "$ENABLE_UBOOT" = true ] ; then
343 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
343 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
344 344 fi
345 345
346 346 # Check if root SSH (v2) public key file exists
347 347 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
348 348 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
349 349 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
350 350 exit 1
351 351 fi
352 352 fi
353 353
354 354 # Check if $USER_NAME SSH (v2) public key file exists
355 355 if [ -n "$SSH_USER_PUB_KEY" ] ; then
356 356 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
357 357 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
358 358 exit 1
359 359 fi
360 360 fi
361 361
362 362 # Check if all required packages are installed on the build system
363 363 for package in $REQUIRED_PACKAGES ; do
364 364 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
365 365 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
366 366 fi
367 367 done
368 368
369 369 # If there are missing packages ask confirmation for install, or exit
370 370 if [ -n "$MISSING_PACKAGES" ] ; then
371 371 echo "the following packages needed by this script are not installed:"
372 372 echo "$MISSING_PACKAGES"
373 373
374 374 printf "\ndo you want to install the missing packages right now? [y/n] "
375 375 read -r confirm
376 376 [ "$confirm" != "y" ] && exit 1
377 377
378 378 # Make sure all missing required packages are installed
379 379 apt-get -qq -y install "${MISSING_PACKAGES}"
380 380 fi
381 381
382 382 # Check if ./bootstrap.d directory exists
383 383 if [ ! -d "./bootstrap.d/" ] ; then
384 384 echo "error: './bootstrap.d' required directory not found!"
385 385 exit 1
386 386 fi
387 387
388 388 # Check if ./files directory exists
389 389 if [ ! -d "./files/" ] ; then
390 390 echo "error: './files' required directory not found!"
391 391 exit 1
392 392 fi
393 393
394 394 # Check if specified KERNELSRC_DIR directory exists
395 395 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
396 396 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
397 397 exit 1
398 398 fi
399 399
400 400 # Check if specified UBOOTSRC_DIR directory exists
401 401 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
402 402 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
403 403 exit 1
404 404 fi
405 405
406 406 # Check if specified FBTURBOSRC_DIR directory exists
407 407 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
408 408 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
409 409 exit 1
410 410 fi
411 411
412 412 # Check if specified CHROOT_SCRIPTS directory exists
413 413 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
414 414 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
415 415 exit 1
416 416 fi
417 417
418 418 # Check if specified device mapping already exists (will be used by cryptsetup)
419 419 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
420 420 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
421 421 exit 1
422 422 fi
423 423
424 424 # Don't clobber an old build
425 425 if [ -e "$BUILDDIR" ] ; then
426 426 echo "error: directory ${BUILDDIR} already exists, not proceeding"
427 427 exit 1
428 428 fi
429 429
430 430 # Setup chroot directory
431 431 mkdir -p "${R}"
432 432
433 433 # Check if build directory has enough of free disk space >512MB
434 434 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
435 435 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
436 436 exit 1
437 437 fi
438 438
439 439 # Call "cleanup" function on various signals and errors
440 440 trap cleanup 0 1 2 3 6
441 441
442 442 # Add required packages for the minbase installation
443 443 if [ "$ENABLE_MINBASE" = true ] ; then
444 444 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
445 445 fi
446 446
447 447 # Add parted package, required to get partprobe utility
448 448 if [ "$EXPANDROOT" = true ] ; then
449 449 APT_INCLUDES="${APT_INCLUDES},parted"
450 450 fi
451 451
452 452 # Add dbus package, recommended if using systemd
453 453 if [ "$ENABLE_DBUS" = true ] ; then
454 454 APT_INCLUDES="${APT_INCLUDES},dbus"
455 455 fi
456 456
457 457 # Add iptables IPv4/IPv6 package
458 458 if [ "$ENABLE_IPTABLES" = true ] ; then
459 459 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
460 460 fi
461 461
462 462 # Add openssh server package
463 463 if [ "$ENABLE_SSHD" = true ] ; then
464 464 APT_INCLUDES="${APT_INCLUDES},openssh-server"
465 465 fi
466 466
467 467 # Add alsa-utils package
468 468 if [ "$ENABLE_SOUND" = true ] ; then
469 469 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
470 470 fi
471 471
472 472 # Add rng-tools package
473 473 if [ "$ENABLE_HWRANDOM" = true ] ; then
474 474 APT_INCLUDES="${APT_INCLUDES},rng-tools"
475 475 fi
476 476
477 477 # Add fbturbo video driver
478 478 if [ "$ENABLE_FBTURBO" = true ] ; then
479 479 # Enable xorg package dependencies
480 480 ENABLE_XORG=true
481 481 fi
482 482
483 483 # Add user defined window manager package
484 484 if [ -n "$ENABLE_WM" ] ; then
485 485 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
486 486
487 487 # Enable xorg package dependencies
488 488 ENABLE_XORG=true
489 489 fi
490 490
491 491 # Add xorg package
492 492 if [ "$ENABLE_XORG" = true ] ; then
493 493 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
494 494 fi
495 495
496 496 # Replace selected packages with smaller clones
497 497 if [ "$ENABLE_REDUCE" = true ] ; then
498 498 # Add levee package instead of vim-tiny
499 499 if [ "$REDUCE_VIM" = true ] ; then
500 500 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
501 501 fi
502 502
503 503 # Add dropbear package instead of openssh-server
504 504 if [ "$REDUCE_SSHD" = true ] ; then
505 505 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
506 506 fi
507 507 fi
508 508
509 509 # Configure kernel sources if no KERNELSRC_DIR
510 510 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
511 511 KERNELSRC_CONFIG=true
512 512 fi
513 513
514 514 # Configure reduced kernel
515 515 if [ "$KERNEL_REDUCE" = true ] ; then
516 516 KERNELSRC_CONFIG=false
517 517 fi
518 518
519 519 set -x
520 520
521 521 # Execute bootstrap scripts
522 522 for SCRIPT in bootstrap.d/*.sh; do
523 523 head -n 4 "$SCRIPT"
524 524 . "$SCRIPT"
525 525 done
526 526
527 527 ## Execute custom bootstrap scripts
528 528 if [ -d "custom.d" ] ; then
529 529 for SCRIPT in custom.d/*.sh; do
530 530 . "$SCRIPT"
531 531 done
532 532 fi
533 533
534 534 # Execute custom scripts inside the chroot
535 535 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
536 536 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
537 537 chroot_exec /bin/bash -x <<'EOF'
538 538 for SCRIPT in /chroot_scripts/* ; do
539 539 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
540 540 $SCRIPT
541 541 fi
542 542 done
543 543 EOF
544 544 rm -rf "${R}/chroot_scripts"
545 545 fi
546 546
547 547 # Remove c/c++ build environment from the chroot
548 548 chroot_remove_cc
549 549
550 550 # Generate required machine-id
551 551 MACHINE_ID=$(dbus-uuidgen)
552 552 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
553 553 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
554 554
555 555 # APT Cleanup
556 556 chroot_exec apt-get -y clean
557 557 chroot_exec apt-get -y autoclean
558 558 chroot_exec apt-get -y autoremove
559 559
560 560 # Unmount mounted filesystems
561 561 umount -l "${R}/proc"
562 562 umount -l "${R}/sys"
563 563
564 564 # Clean up directories
565 565 rm -rf "${R}/run/*"
566 566 rm -rf "${R}/tmp/*"
567 567
568 568 # Clean up files
569 569 rm -f "${ETC_DIR}/ssh/ssh_host_*"
570 570 rm -f "${ETC_DIR}/dropbear/dropbear_*"
571 571 rm -f "${ETC_DIR}/apt/sources.list.save"
572 572 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
573 573 rm -f "${ETC_DIR}/*-"
574 574 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
575 575 rm -f "${ETC_DIR}/resolv.conf"
576 576 rm -f "${R}/root/.bash_history"
577 577 rm -f "${R}/var/lib/urandom/random-seed"
578 578 rm -f "${R}/initrd.img"
579 579 rm -f "${R}/vmlinuz"
580 580 rm -f "${R}${QEMU_BINARY}"
581 581
582 582 if [ "$ENABLE_QEMU" = true ] ; then
583 583 # Configure qemu compatible kernel
584 584 DTB_FILE=vexpress-v2p-ca15_a7.dtb
585 585 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
586 586 KERNEL_DEFCONFIG="vexpress_defconfig"
587 587 if [ "$KERNEL_MENUCONFIG" = false ] ; then
588 588 KERNEL_OLDDEFCONFIG=true
589 589 fi
590 590
591 591 # Setup QEMU directory
592 592 mkdir "${BASEDIR}/qemu"
593 593
594 594 # Copy kernel image to QEMU directory
595 595 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
596 596
597 597 # Copy kernel config to QEMU directory
598 598 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
599 599
600 600 # Copy kernel dtbs to QEMU directory
601 601 for dtb in "${BOOT_DIR}/"*.dtb ; do
602 602 if [ -f "${dtb}" ] ; then
603 603 install_readonly "${dtb}" "${BASEDIR}/qemu/"
604 604 fi
605 605 done
606 606
607 607 # Copy kernel overlays to QEMU directory
608 608 if [ -d "${BOOT_DIR}/overlays" ] ; then
609 609 # Setup overlays dtbs directory
610 610 mkdir "${BASEDIR}/qemu/overlays"
611 611
612 612 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
613 613 if [ -f "${dtb}" ] ; then
614 614 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
615 615 fi
616 616 done
617 617 fi
618 618
619 619 # Copy u-boot files to QEMU directory
620 620 if [ "$ENABLE_UBOOT" = true ] ; then
621 621 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
622 622 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
623 623 fi
624 624 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
625 625 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
626 626 fi
627 627 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
628 628 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
629 629 fi
630 630 fi
631 631
632 632 # Copy initramfs to QEMU directory
633 633 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
634 634 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
635 635 fi
636 636 fi
637 637
638 638 # Calculate size of the chroot directory in KB
639 639 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
640 640
641 641 # Calculate the amount of needed 512 Byte sectors
642 642 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
643 643 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
644 644 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
645 645
646 646 # The root partition is EXT4
647 647 # This means more space than the actual used space of the chroot is used.
648 648 # As overhead for journaling and reserved blocks 35% are added.
649 649 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
650 650
651 651 # Calculate required image size in 512 Byte sectors
652 652 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
653 653
654 654 # Prepare image file
655 655 if [ "$ENABLE_SPLITFS" = true ] ; then
656 656 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
657 657 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
658 658 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
659 659 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
660 660
661 661 # Write firmware/boot partition tables
662 662 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
663 663 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
664 664 EOM
665 665
666 666 # Write root partition table
667 667 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
668 668 "${TABLE_SECTORS}","${ROOT_SECTORS}",83
669 669 EOM
670 670
671 671 # Setup temporary loop devices
672 672 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
673 673 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
674 674 else # ENABLE_SPLITFS=false
675 675 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
676 676 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
677 677
678 678 # Write partition table
679 679 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
680 680 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
681 681 "${ROOT_OFFSET}","${ROOT_SECTORS}",83
682 682 EOM
683 683
684 684 # Setup temporary loop devices
685 685 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
686 686 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
687 687 fi
688 688
689 689 if [ "$ENABLE_CRYPTFS" = true ] ; then
690 690 # Create dummy ext4 fs
691 691 mkfs.ext4 "$ROOT_LOOP"
692 692
693 693 # Setup password keyfile
694 694 touch .password
695 695 chmod 600 .password
696 696 echo -n "${CRYPTFS_PASSWORD}" > .password
697 697
698 698 # Initialize encrypted partition
699 699 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
700 700
701 701 # Open encrypted partition and setup mapping
702 702 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
703 703
704 704 # Secure delete password keyfile
705 705 shred -zu .password
706 706
707 707 # Update temporary loop device
708 708 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
709 709
710 710 # Wipe encrypted partition (encryption cipher is used for randomness)
711 711 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
712 712 fi
713 713
714 714 # Build filesystems
715 715 mkfs.vfat "$FRMW_LOOP"
716 716 mkfs.ext4 "$ROOT_LOOP"
717 717
718 718 # Mount the temporary loop devices
719 719 mkdir -p "$BUILDDIR/mount"
720 720 mount "$ROOT_LOOP" "$BUILDDIR/mount"
721 721
722 722 mkdir -p "$BUILDDIR/mount/boot/firmware"
723 723 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
724 724
725 725 # Copy all files from the chroot to the loop device mount point directory
726 726 rsync -a "${R}/" "$BUILDDIR/mount/"
727 727
728 728 # Unmount all temporary loop devices and mount points
729 729 cleanup
730 730
731 731 # Create block map file(s) of image(s)
732 732 if [ "$ENABLE_SPLITFS" = true ] ; then
733 733 # Create block map files for "bmaptool"
734 734 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
735 735 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
736 736
737 737 # Image was successfully created
738 738 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
739 739 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
740 740 else
741 741 # Create block map file for "bmaptool"
742 742 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
743 743
744 744 # Image was successfully created
745 745 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
746 746
747 747 # Create qemu qcow2 image
748 748 if [ "$ENABLE_QEMU" = true ] ; then
749 749 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
750 750 QEMU_SIZE=16G
751 751
752 752 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
753 753 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
754 754
755 755 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
756 756 fi
757 757 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant